// SPDX-License-Identifier: MPL-2.0

import asia, { loadConfig } from "asia-core";
import path from "node:path";
import process from "node:process";

import Cache from "./cache.js";

const configPath = path.resolve(process.cwd(), "asia.config.js");
const config = await loadConfig(configPath);

let cache = process.env.ASIA_NO_CACHE === "1" ? new Map() : new Cache(config);

if (process.env.ASIA_RELOAD === "1") {
  await cache.clear();
}

// console.log("config", config);
const { test, run } = asia({ tests: cache, ...config });

export { test, run, asia, Cache, config };
export default test;

if (process.env.ASIA_NO_AUTORUN === undefined) {
  process.nextTick(run);
} else {
  // console.log({ test, run, asia, Cache, config });
}
